#/bin/bash

#export PYTHONPATH="${PYTHONPATH}:/workspace/code"
#export GPU_ID=0,1
export GPU_ID=3

checkpoint_path=/mnt/efs/fs2/hzt/causal/Optimus/checkpoints/
output_path=/mnt/efs/fs2/hzt/causal/Optimus/outputs/
data_path=/mnt/efs/fs2/hzt/causal/Optimus/data/

## Yelp

debug=0

attribute_dim=50
if [ "$debug" -eq 1 ]
then
    TRAIN_FILE=data/datasets/yelp_data_tst/small/train.txt
    TRAIN_FILE_SEMI=data/datasets/yelp_data_tst/small/train_semi.txt
    #TEST_FILE=data/datasets/yelp_data_tst/small/test.txt
    TEST_FILE=data/datasets/yelp_data_tst/small/train.txt
    logging_steps=1
    save_steps=20000
    per_gpu_train_batch_size=2
    per_gpu_eval_batch_size=2
    num_train_epochs=100
else
    #TRAIN_FILE=${data_path}/multi_yelp_tst/full/yelp_text_attrs_10_15_cor80_train.txt
    #TEST_FILE=${data_path}/multi_yelp_tst/full/yelp_text_attrs_10_15_cor80_dev.txt.sub.5594
    TRAIN_FILE=data/datasets/bias_yelp_data_tst/yelp_text_attrs_5_15_cor90_train.txt.reformat.len20
    TRAIN_FILE_SEMI=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean_semi/yelp_text_attrs_5_15_cor90_train.txt.reformat.len20.semi
    TEST_FILE=data/datasets/bias_yelp_data_tst/yelp_text_attrs_5_15_cor90_dev.txt.reformat.sub.5771.len20
    logging_steps=2000
    save_steps=2000
    per_gpu_train_batch_size=8
    per_gpu_eval_batch_size=8
    num_train_epochs=10
fi


### ==================================
## semi, beta, cond_c
###
#
#TRAIN_FILE=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean/cond_c/multi_train_with_predicted_category_labels.tsv
#TRAIN_FILE_SEMI=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean/cond_c/multi_train_semi_with_predicted_category_labels.tsv
#TEST_FILE=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean/cond_c/multi_dev_with_predicted_category_labels.tsv
#
#checkpoint_dir="${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak"
#gloabl_step_eval=242000
#
#    #--ratio_zero 0.5 \
#
#CUDA_VISIBLE_DEVICES=$GPU_ID python3 code/examples/big_ae/run_lm_vae_clas_training_bak_bias.py \
#    --multi_attribute \
#    --cond_c \
#    --semi \
#    --eval_elbo \
#    --beta 1.0 \
#    --ratio_zero 0.5 \
#    --ratio_increase 0.25 \
#    --use_gumbel \
#    --output_dir=${checkpoint_dir}/outputs-242000/cond_c/condc-semi-s2-gsfixed-newmask-t05_wc01_wzc01_wz01_w1_wr01_lr1e6_gumbel_samelen_bz8_dtrm_bak \
#    --learning_rate 1e-6 \
#    --temperature=0.5 \
#    --lambda_c_loss=0.1 \
#    --lambda_reg_z_c=0.1 \
#    --lambda_reg_z=0.1 \
#    --lambda_clas=1 \
#    --lambda_recon=0.1 \
#    --temperature_anneal_factor=1 \
#    --temperature_anneal_iters=20000 \
#    --checkpoint_dir=${checkpoint_dir} \
#    --gloabl_step_eval ${gloabl_step_eval} \
#    --attribute_dim $attribute_dim \
#    --dataset Yelp \
#    --encoder_model_type=gpt2-encoder \
#    --encoder_model_name_or_path=gpt2 \
#    --decoder_model_type=gpt2 \
#    --decoder_model_name_or_path=gpt2 \
#    --classifier_model_type=gpt2-clas \
#    --classifier_model_name_or_path=gpt2 \
#    --do_train \
#    --fb_mode 1 \
#    --dim_target_kl 0.5\
#    --train_data_file_2=${TRAIN_FILE_SEMI} \
#    --train_data_file=$TRAIN_FILE \
#    --eval_data_file=$TEST_FILE \
#    --num_train_epochs ${num_train_epochs} \
#    --save_steps ${save_steps}\
#    --logging_steps ${logging_steps} \
#    --overwrite_output_dir \
#    --block_size 100 \
#    --length_weighted_loss \
#    --use_pretrained_model \
#    --use_pretrained_vae \
#    --latent_size 768 \
#    --evaluate_during_training \
#    --per_gpu_train_batch_size ${per_gpu_train_batch_size} \
#    --per_gpu_eval_batch_size ${per_gpu_eval_batch_size}




## ==================================
# semi, TST
##

#checkpoint_dir="${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak"
#gloabl_step_eval=242000
##checkpoint_dir="/mnt/efs/fs2/hzt/causal/Optimus/outputs//finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak/outputs-242000/tst/tst-dtrm-semi-s180-gsfixed-newmask-t1_wc0_wzc0_wz0_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak/"
##gloabl_step_eval=32000
#
#    #--eval_elbo \
#    #--learning_rate 1e-6 \
#
#CUDA_VISIBLE_DEVICES=$GPU_ID python3 code/examples/big_ae/run_lm_vae_clas_training_bak_bias.py \
#    --eval_elbo \
#    --use_deterministic_connect \
#    --beta 0 \
#    --semi \
#    --use_gumbel \
#    --output_dir=${checkpoint_dir}/outputs-242000/tst/tst-dtrm-beta0-semi-s134-gsfixed-newmask-t05_wc01_wzc01_wz01_w1_wr01_lr1e6_gumbel_samelen_bz8_dtrm_bak \
#    --learning_rate 1e-6 \
#    --temperature=0.5 \
#    --lambda_c_loss=0.1 \
#    --lambda_reg_z_c=0.1 \
#    --lambda_reg_z=0.1 \
#    --lambda_clas=1 \
#    --lambda_recon=0.1 \
#    --temperature_anneal_factor=1 \
#    --temperature_anneal_iters=20000 \
#    --checkpoint_dir=${checkpoint_dir} \
#    --gloabl_step_eval ${gloabl_step_eval} \
#    --attribute_dim $attribute_dim \
#    --dataset Yelp \
#    --encoder_model_type=gpt2-encoder \
#    --encoder_model_name_or_path=gpt2 \
#    --decoder_model_type=gpt2 \
#    --decoder_model_name_or_path=gpt2 \
#    --classifier_model_type=gpt2-clas \
#    --classifier_model_name_or_path=gpt2 \
#    --ratio_zero 0.5 \
#    --ratio_increase 0.25 \
#    --do_train \
#    --fb_mode 1 \
#    --dim_target_kl 0.5\
#    --train_data_file_2=${TRAIN_FILE_SEMI} \
#    --train_data_file=$TRAIN_FILE \
#    --eval_data_file=$TEST_FILE \
#    --num_train_epochs ${num_train_epochs} \
#    --save_steps ${save_steps}\
#    --logging_steps ${logging_steps} \
#    --overwrite_output_dir \
#    --block_size 100 \
#    --length_weighted_loss \
#    --use_pretrained_model \
#    --use_pretrained_vae \
#    --latent_size 768 \
#    --evaluate_during_training \
#    --per_gpu_train_batch_size ${per_gpu_train_batch_size} \
#    --per_gpu_eval_batch_size ${per_gpu_eval_batch_size}


#### ==================================
### semi, beta
####
##
#checkpoint_dir="${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak"
#gloabl_step_eval=242000
#
#    #--ratio_zero 0.5 \
#
#CUDA_VISIBLE_DEVICES=$GPU_ID python3 code/examples/big_ae/run_lm_vae_clas_training_bak_bias.py \
#    --semi \
#    --eval_elbo \
#    --beta 2.0 \
#    --ratio_zero 0.1 \
#    --ratio_increase 0.25 \
#    --use_gumbel \
#    --output_dir=${checkpoint_dir}/outputs-242000/semi-beta2-ratiozero01-s2-gsfixed-newmask-t05_wc05_wzc05_wz0_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak \
#    --learning_rate 1e-6 \
#    --temperature=0.5 \
#    --lambda_c_loss=0.5 \
#    --lambda_reg_z_c=0.5 \
#    --lambda_reg_z=0 \
#    --lambda_clas=0.5 \
#    --lambda_recon=1 \
#    --temperature_anneal_factor=1 \
#    --temperature_anneal_iters=20000 \
#    --checkpoint_dir=${checkpoint_dir} \
#    --gloabl_step_eval ${gloabl_step_eval} \
#    --attribute_dim $attribute_dim \
#    --dataset Yelp \
#    --encoder_model_type=gpt2-encoder \
#    --encoder_model_name_or_path=gpt2 \
#    --decoder_model_type=gpt2 \
#    --decoder_model_name_or_path=gpt2 \
#    --classifier_model_type=gpt2-clas \
#    --classifier_model_name_or_path=gpt2 \
#    --do_train \
#    --fb_mode 1 \
#    --dim_target_kl 0.5\
#    --train_data_file_2=${TRAIN_FILE_SEMI} \
#    --train_data_file=$TRAIN_FILE \
#    --eval_data_file=$TEST_FILE \
#    --num_train_epochs ${num_train_epochs} \
#    --save_steps ${save_steps}\
#    --logging_steps ${logging_steps} \
#    --overwrite_output_dir \
#    --block_size 100 \
#    --length_weighted_loss \
#    --use_pretrained_model \
#    --use_pretrained_vae \
#    --latent_size 768 \
#    --evaluate_during_training \
#    --per_gpu_train_batch_size ${per_gpu_train_batch_size} \
#    --per_gpu_eval_batch_size ${per_gpu_eval_batch_size}
#

## ==================================

## VAE from scratch

logging_steps=2000
save_steps=2000
per_gpu_train_batch_size=16
per_gpu_eval_batch_size=16

    #--cond_a \

# Basic
CUDA_VISIBLE_DEVICES=$GPU_ID python3 code/examples/big_ae/run_lm_vae_clas_training_bak_bias.py \
    --cond_c \
    --multi_attribute \
    --eval_elbo \
    --beta 1.0 \
    --use_gumbel \
    --output_dir=${output_path}/finetune_lm/vae_gpt2encoder/basic-condc-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak \
    --learning_rate 5e-5 \
    --temperature=1 \
    --lambda_clas=0 \
    --lambda_recon=1 \
    --temperature_anneal_factor=1 \
    --temperature_anneal_iters=20000 \
    --checkpoint_dir=${checkpoint_path}/checkpoint-31250 \
    --gloabl_step_eval 31250 \
    --attribute_dim $attribute_dim \
    --dataset Yelp \
    --encoder_model_type=gpt2-encoder \
    --encoder_model_name_or_path=gpt2 \
    --decoder_model_type=gpt2 \
    --decoder_model_name_or_path=gpt2 \
    --classifier_model_type=gpt2-clas \
    --classifier_model_name_or_path=gpt2 \
    --ratio_zero 0.5 \
    --ratio_increase 0.25 \
    --do_train \
    --do_eval \
    --fb_mode 1 \
    --dim_target_kl 0.5\
    --train_data_file=$TRAIN_FILE \
    --eval_data_file=$TEST_FILE \
    --num_train_epochs ${num_train_epochs} \
    --save_steps ${save_steps}\
    --logging_steps ${logging_steps} \
    --overwrite_output_dir \
    --block_size 100 \
    --length_weighted_loss \
    --latent_size 768 \
    --evaluate_during_training \
    --per_gpu_train_batch_size ${per_gpu_train_batch_size} \
    --per_gpu_eval_batch_size ${per_gpu_eval_batch_size}



#### ==================================
### train a layer given z
####
##
#
#TRAIN_FILE=data/datasets/bias_yelp_data_tst/yelp_text_attrs_5_15_cor90_train.txt.reformat.len20
#TEST_FILE=data/datasets/bias_yelp_data_tst/yelp_text_attrs_5_15_cor90_dev.txt.reformat.sub.5771.len20
##TRAIN_FILE=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean/yelp_text_attrs_5_15_cor90_test.txt.reformat.len20.sub.511972
##TEST_FILE=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean/yelp_text_attrs_5_15_cor90_test.txt.reformat.len20.sub.6562
#
#logging_steps=4000
#save_steps=4000
#per_gpu_train_batch_size=16
#per_gpu_eval_batch_size=16
#num_train_epochs=5
#
#output_dir=${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak/outputs-242000/debug-semi-s2-gsfixed-newmask-t05_wc05_wzc05_wz05_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak
#checkpoint_dir=${output_dir}
#gloabl_step_eval=272000
#
##output_dir=${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak/outputs-242000/debug-semi-s2-gsfixed-newmask-t05_wc05_wzc05_wz05_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak/outputs-272000/train_a_layer_dtrm_lr1e4_it272000_2layer_2_debug-semi-s2-gsfixed-newmask-t05_wc05_wzc05_wz05_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak
##gloabl_step_eval=10000
##checkpoint_dir=${output_dir}
#
#
#CUDA_VISIBLE_DEVICES=$GPU_ID python3 code/examples/big_ae/run_lm_vae_clas_training_bak_bias.py \
#    --do_train_a_layer \
#    --use_deterministic_connect \
#    --beta 1.0 \
#    --use_gumbel \
#    --output_dir=${output_dir}/outputs-${gloabl_step_eval}/train_a_layer_dtrm_lr1e4_it${gloabl_step_eval}_2layerwide_ep5_debug-semi-s2-gsfixed-newmask-t05_wc05_wzc05_wz05_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak \
#    --learning_rate 1e-4 \
#    --checkpoint_dir=${checkpoint_dir} \
#    --gloabl_step_eval ${gloabl_step_eval} \
#    --attribute_dim $attribute_dim \
#    --dataset Yelp \
#    --encoder_model_type=gpt2-encoder \
#    --encoder_model_name_or_path=gpt2 \
#    --decoder_model_type=gpt2 \
#    --decoder_model_name_or_path=gpt2 \
#    --classifier_model_type=gpt2-clas \
#    --classifier_model_name_or_path=gpt2 \
#    --ratio_zero 0.5 \
#    --ratio_increase 0.25 \
#    --fb_mode 1 \
#    --dim_target_kl 0.5\
#    --train_data_file_2=${TRAIN_FILE_SEMI} \
#    --train_data_file=$TRAIN_FILE \
#    --eval_data_file=$TEST_FILE \
#    --num_train_epochs ${num_train_epochs} \
#    --save_steps ${save_steps}\
#    --logging_steps ${logging_steps} \
#    --overwrite_output_dir \
#    --block_size 100 \
#    --length_weighted_loss \
#    --use_pretrained_model \
#    --use_pretrained_vae \
#    --latent_size 768 \
#    --evaluate_during_training \
#    --per_gpu_train_batch_size ${per_gpu_train_batch_size} \
#    --per_gpu_eval_batch_size ${per_gpu_eval_batch_size}



### ==================================
## train gan
###
#

#TRAIN_FILE=data/datasets/bias_yelp_data_tst/yelp_text_attrs_5_15_cor90_train.txt.reformat.len20
##TEST_FILE=data/datasets/bias_yelp_data_tst/yelp_text_attrs_5_15_cor90_dev.txt.reformat.sub.5771.len20
##TRAIN_FILE=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean/yelp_text_attrs_5_15_cor90_test.txt.reformat.len20.sub.511972
#TEST_FILE=/mnt/efs/fs2/hzt/causal/Optimus/data/multi_yelp_tst/full_5_15_clean/yelp_text_attrs_5_15_cor90_test.txt.reformat.len20.sub.6562
#
#logging_steps=2000
#save_steps=2000
##logging_steps=4000
##save_steps=4000
#per_gpu_train_batch_size=16
#per_gpu_eval_batch_size=16
#num_train_epochs=5
#
##output_dir=${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak/outputs-242000/semi-s2-gsfixed-newmask-t05_wc05_wzc05_wz0_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak
##checkpoint_dir=${output_dir}
##gloabl_step_eval=272000
#
##output_dir=${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak/outputs-242000/tst/tst-dtrm-beta0-semi-s134-gsfixed-newmask-t05_wc01_wzc01_wz01_w1_wr02_lr1e6_gumbel_samelen_bz8_dtrm_bak
##checkpoint_dir=${output_dir}
##gloabl_step_eval=56000
#
#output_dir=${output_path}/finetune_lm/vae_gpt2encoder/basic-s2-beta1-gsfixed-newmask-t1_w0_wr1_lr5e5_gumbel_samelen_bz16_bak/outputs-242000/debug-semi-s2-gsfixed-newmask-t05_wc05_wzc05_wz05_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak
#checkpoint_dir=${output_dir}
#gloabl_step_eval=226000
#
#
#CUDA_VISIBLE_DEVICES=$GPU_ID python3 code/examples/big_ae/run_lm_vae_clas_training_bak_bias.py \
#    --do_train_gan \
#    --nsamples 100 \
#    --use_deterministic_connect \
#    --beta 1.0 \
#    --use_gumbel \
#    --output_dir=${output_dir}/outputs-${gloabl_step_eval}/train_gan_dtrm_lr1e4_it${gloabl_step_eval}_ep5_debug-semi-s2-gsfixed-newmask-t05_wc05_wzc05_wz05_w05_wr1_lr1e6_gumbel_samelen_bz8_dtrm_bak_it226000 \
#    --learning_rate 1e-4 \
#    --checkpoint_dir=${checkpoint_dir} \
#    --gloabl_step_eval ${gloabl_step_eval} \
#    --attribute_dim $attribute_dim \
#    --dataset Yelp \
#    --encoder_model_type=gpt2-encoder \
#    --encoder_model_name_or_path=gpt2 \
#    --decoder_model_type=gpt2 \
#    --decoder_model_name_or_path=gpt2 \
#    --classifier_model_type=gpt2-clas \
#    --classifier_model_name_or_path=gpt2 \
#    --ratio_zero 0.5 \
#    --ratio_increase 0.25 \
#    --fb_mode 1 \
#    --dim_target_kl 0.5\
#    --train_data_file_2=${TRAIN_FILE_SEMI} \
#    --train_data_file=$TRAIN_FILE \
#    --eval_data_file=$TEST_FILE \
#    --num_train_epochs ${num_train_epochs} \
#    --save_steps ${save_steps}\
#    --logging_steps ${logging_steps} \
#    --overwrite_output_dir \
#    --block_size 100 \
#    --length_weighted_loss \
#    --use_pretrained_model \
#    --use_pretrained_vae \
#    --latent_size 768 \
#    --evaluate_during_training \
#    --per_gpu_train_batch_size ${per_gpu_train_batch_size} \
#    --per_gpu_eval_batch_size ${per_gpu_eval_batch_size}
#
#

